package io.zipcoder.crudapp;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.StreamSupport;

@RestController
public class PersonController{

    @Autowired
    PersonRepository personRepository;

    //  var URI = "http://localhost:8080/people/";

    @PostMapping("/people")
    ResponseEntity<Person> createPerson(@RequestBody Person person){
        return new ResponseEntity<>(
                personRepository.save(person),
                HttpStatus.CREATED
        );
    }

    @GetMapping("/people/{id}")
    ResponseEntity<Person> getPerson(@PathVariable int id){
        return new ResponseEntity<>(
                personRepository.findOne(id), HttpStatus.OK
        );
    }

    @GetMapping("/people")
    ResponseEntity<Iterable<Person>> getPersonList(){
        return new ResponseEntity<>(
                personRepository.findAll(), HttpStatus.OK
        );
    }

    @RequestMapping(value = "/people/{id}", method = RequestMethod.PUT)
    ResponseEntity<Person> updatePerson(Person person){
        return new ResponseEntity<>(
            personRepository.save(person), HttpStatus.OK
        );
    }

//    @RequestMapping(path="/user/{userId}",method=RequestMethod.PUT)
//    public ResponseEntity<Void> updateExist(@RequestBody User user,@PathVariable long userId)  {
//        try {
//            user.setUserId(userId);
//            userService.update(user);
//            return ResponseEntity.noContent().build();
//        } catch (ResourceNotFoundException e) {
//            return ResponseEntity.notFound().build();
//        }
//    }

    @DeleteMapping("/people/{id}")
    void deletePerson(@PathVariable int id){
                personRepository.delete(id);
    }

}
